Home > Articles > Programming > Python

An Introduction to Object-Oriented Concepts in Python, Part 4

  • Print
  • + Share This
Programming expert Jesse Smith shows how to make Python programs more robust by using exceptions.
Like this article? We recommend

In this article, I'll continue showing you how to use Python from an object-oriented (OO) point of view. If you're unfamiliar with object-oriented concepts such as inheritance, encapsulation, and polymorphism, read my article "A Primer on Object-Oriented Concepts" before continuing with this article.

This article builds on my earlier article "An Introduction to Object-Oriented Concepts in Python, Part 3." If you haven't read that article already, please read it before reading this article. The concepts in this article will take a closer look at Python exception handling.

If you've been following my Python series, you know how classes in Python work. But so far I haven't addressed how Python classes are used to raise exceptions. As in other programming languages, it's necessary to raise exceptions that not only help programmers to identify problems, but alert program users to errors.


Miss the Earlier Articles in this Python Series?

In case you joined late, here are the earlier installments in this article series:


Python Exceptions

Like everything else in Python, an exception is really just an object. All exceptions are derived from the BasicException class. As in other languages, Python uses a familiar try...except block to capture an exception, but a raise keyword to throw exceptions. This differs from other languages that commonly use throw to throw new exceptions and a try...catch block to catch exceptions.

Python has a lot of built-in exceptions that are raised if no other code catches them. One simple example, which you've likely already seen, is the SyntaxError exception. To raise this exception, simply use the print function without parentheses:

print "hello world"

The Python interpreter expects parentheses with the reserved print function name; when it doesn't find them, a SyntaxError exception is thrown. This type of exception is referred to as an unhandled exception. No code was there to catch the exception using the try...except block. If we don't handle the exception, the whole program halts in execution—and crashes. The SyntaxError exception is a special exception that we can't handle explicitly in a program. This type of exception is known as a compile-time error. The program won't run until this type of exception is corrected during code compilation (before the program executes). Quite a few built-in exceptions can't be handled that are not compile-time errors, but instead are runtime errors. These exceptions occur while the program is running and are triggered by either a system or user condition. For example, let's say we have an equation completed by user input. If the user enters 0, we can handle (catch) the built-in ZeroDivisionError exception by sending the user a friendly message:

try:
    y = 0
    x = 10/y
except ZeroDivisionError:
    print("invalid input, cannot divide by 0")

Any statements after the print statement in this example would be executed normally. The important thing to note here is that, because the exception was handled, the program resumes without crashing.

What if you want to raise your own exception? To do this, use the raise keyword:

y = 0
if y == 0:
    raise ZeroDivisionError("invalid input, cannot divide by 0")

In this example, we test the condition for division by 0; if the condition is true, we raise the ZeroDivisionError exception in our code. The program throws the exception and halts execution because there's no code to handle (catch) it. Our exception bubbles up to each previous piece of calling code until it reaches the top. If no code is found to handle the exception, we get the exception message and stack trace.

What if we wanted to raise our own exceptions? In some instances, none of the built-in exceptions will work as we intended. To raise our own exceptions, we create a class that's derived from the built-in Exception class, which in turn is derived from the BaseException class:

class InvalidFeature(Exception):
    pass
raise InvalidFeature("this is not a valid feature for this product")

Notice that we don't need to add any code to our exception class. Everything we need is from the built-in Exception class. When running this code, it will behave just like the Python built-in exceptions. To expand on custom exceptions, we can pass parameters into the __init__ method of our exception class:

class InvalidFeature(Exception):
    def __init__(self, feature):
        if feature != "automatic transmission":
            super().__init__("this is not a valid feature for this product")
raise InvalidFeature("power steering")

We pass in a feature to our custom exception class and test for a valid feature, if not a valid feature, the __init__ class of the Exception superclass is called to print out the message.  You could just as easily add other methods to your custom exception class. You can also use the as keyword, as other languages do when catching an exception:

class InvalidFeature(Exception):
    def __init__(self, feature):
        if feature != "automatic transmission":
            print("Invalid Feature")
try:
   raise InvalidFeature("automatic transmission")
except InvalidFeature as e:
    e.__init__("anti-lock brakes")

When running this code, instead of the interpreter printing out the error message, we print out the message in a friendly format that doesn't halt execution of the program.  You could use the return keyword in your custom exception class for more elegant results.

Conclusion

In this article, you learned how to use exceptions in Python programs by using built-in exceptions. It's important to note that all exception classes, whether built-in or custom-created, are derived from the BaseException class. When creating custom exceptions, the custom class is derived from the built-in Exception class. The __init__ method of the Exception class can be used in a custom class to provide custom messages. "Raising an exception" refers to the ability to throw exceptions in our code. When we raise exceptions, they're not handled unless code is included in the program to handle the exceptions. There are various program states in which built-in exceptions can occur. Exceptions raised by the Python interpreter during compilation are known as compile-time exceptions. Exceptions raised by a user or system action within the program are referred to as runtime exceptions. We can handle runtime exceptions in our programs and continue execution of the program, but we're unable to handle compile-time exceptions, which halt the program altogether.

At this stage, you should be comfortable using built-in exceptions, along with creating your own custom exceptions. Knowing the difference is important, as sometimes the built-in exceptions won't suffice and a custom one is necessary. Python is a little different from other languages in that it uses the except and raise keywords, as opposed to the catch and throw keywords. (I refer to these as keywords, but they're really just built-in functions.)

In Part 5 of this series, I'll continue OO concepts by covering file handling and data structures. These concepts are important for program flow and well-designed Python programs.

  • + Share This
  • 🔖 Save To Your Account